/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2011 Gabriele Dini Ciacci

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on April 27, 2011, 6:37 PM
 */

#include "u2d_ScalarFieldOutput.h"

#include "boost/numeric/mtl/mtl.hpp"

u2d_ScalarFieldOutput::u2d_ScalarFieldOutput() {
}

u2d_ScalarFieldOutput::u2d_ScalarFieldOutput(string _filename, dense_vector<double> _values) :
u2d_ValuesOutput(_filename),
values(_values) {
}


u2d_ScalarFieldOutput::u2d_ScalarFieldOutput(const u2d_ScalarFieldOutput& orig) {
}

u2d_ScalarFieldOutput::~u2d_ScalarFieldOutput() {
}

void u2d_ScalarFieldOutput::output()
    throw (u2d_IO_Exception&) {
    try {
        openFile();
        for(size_t i = 0; i < mtl::size(values); i++) {
            printScalarValueLine(values(i));
        }
        closeFile();
    }
    catch (...) {
        throw;
    }
}

void u2d_ScalarFieldOutput::setValues(dense_vector<double> _values){
    values = _values;
}