/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2011 Gabriele Dini Ciacci

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on April 27, 2011, 5:37 PM
 */

#ifndef U2D_VALUESOUTPUT_H
#define	U2D_VALUESOUTPUT_H

#include <string>
#include <exceptions.h>

#include "u2d_file_output.h"
#include "boost/numeric/mtl/mtl.hpp"

using std::string;
using namespace mtl;

class u2d_ValuesOutput : public u2d_FileOutput {
public:
    u2d_ValuesOutput();
    u2d_ValuesOutput(string _filename);
    virtual ~u2d_ValuesOutput();
    virtual void output() throw (u2d_IO_Exception &) = 0;
    void setFilename(string filename) throw (u2d_Parse_Error_Exception &);
    string getFilename();
    void printScalarValueLine(double scalar);
    void print2DVectorValueLine(double x, double y);
    void print3DVectorValueLine(double x, double y, double z);
protected:
    void openFile() throw (u2d_IO_Exception &);
    void closeFile() throw (u2d_IO_Exception &);
private:
    string filename;
    FILE *file;
};


#endif	/* U2D_VALUESOUTPUT_H */

