/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2011 Gabriele Dini Ciacci

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on April 27, 2011, 6:37 PM
 */

#ifndef U2D_VECTORFIELDOUTPUT_H
#define	U2D_VECTORFIELDOUTPUT_H

#include <string>
#include <exceptions.h>

#include "u2d_ValuesOutput.h"
#include "boost/numeric/mtl/mtl.hpp"

using std::string;
using namespace mtl;

class u2d_VectorFieldOutput : public u2d_ValuesOutput {
public:
    u2d_VectorFieldOutput();
    u2d_VectorFieldOutput(string _filename, dense2D<double> _values, int _spatial_dim);
    virtual ~u2d_VectorFieldOutput();
    void output() throw (u2d_IO_Exception &);
    void setValues(dense2D<double> values);
private:
    int spatial_dim;
    string filename;
    dense2D<double> values;
};


#endif	/* U2D_VECTORFIELDOUTPUT_H */

