/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2010 Gabriele Dini Ciacci <dark.schneider@iol.it>
    Based on a code from Luigi Quartapelle and Massimo Biava

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on January 24, 2010, 6:56 PM
 */

#ifndef U2D_NEUMANNCONDITION_H
#define	U2D_NEUMANNCONDITION_H

#include <iostream>
#include <set> // for std::set

#include "boost/numeric/mtl/mtl.hpp"
#include "u2d_Mesh.h"


using namespace mtl;

class u2d_NeumannCondition {
public:
    u2d_NeumannCondition();
    u2d_NeumannCondition(const u2d_NeumannCondition& orig);
    virtual ~u2d_NeumannCondition();
    void calculateElements(u2d_Mesh* mesh);
    int setSide(int side_id);
    bool isNeumann(int side_id);
    size_t getNuemannElementNumber();

    dense_vector<int> neumann_elements;
private:
    void countElements(u2d_Mesh* mesh);
    size_t neumann_element_n;
    std::vector<int> neu_sides;
};

#endif	/* U2D_NEUMANNCONDITION_H */

